Index: trunk/SophyaPI/PIext/cxxexecutor.cc
===================================================================
--- trunk/SophyaPI/PIext/cxxexecutor.cc	(revision 1315)
+++ trunk/SophyaPI/PIext/cxxexecutor.cc	(revision 1319)
@@ -27,5 +27,8 @@
 mModuleImportDefaultList.push_back("Samba");
 mModuleImportDefaultList.push_back("SkyMap");
-mModuleImportDefaultList.push_back("PMixer");
+mModuleImportDefaultList.push_back("SkyT");
+mModuleImportDefaultList.push_back("FitsIOServer");
+mModuleImportDefaultList.push_back("IFFTW");
+mModuleImportDefaultList.push_back("LinAlg");
 
 // Gestion des fichiers par default dans TmpDir 
@@ -364,8 +367,26 @@
 os<<endl;
 
+os<<"//---- function for Adding and displaying Objects  " << endl;
+os<<"void Keep_Object(AnyDataObj & obj, string const & nom) \n{ \n" 
+  <<"  string name = nom; \n  NamedObjMgr om; \n"
+  <<"  if (om.GetObj(name)) \n" 
+  <<"    cerr << \"KeepObj()/Warning Already kept object \" << endl; \n"
+  <<"  else om.AddObj(obj, name); \n"
+  <<"} \n" << endl;
+os<<"void Display_Object(AnyDataObj & obj, string const & opt, string const & nom) \n { \n" 
+  <<"  string name = nom; \n  NamedObjMgr om; \n"
+  <<"  if (!om.GetObj(name)) \n" 
+  <<"    om.AddObj(obj, name); \n"
+  <<"  om.DisplayObj(name, opt); \n"
+  <<"} \n" << endl;
+
 os<<"//---- Objects and variables saving"<<endl
-  <<"#define KeepObj(obj) ___nomobj = #obj; omg.AddObj(obj,___nomobj);"<<endl
+  <<"#define KeepObj(obj) Keep_Object(obj, #obj);"<<endl
   <<"#define KeepVar(var) ___nomobj = #var; omg.GetVarList().Get(___nomobj) = var ;"<<endl
   <<endl;
+
+os<<"//---- Displaying objects and command execution"<<endl;
+os<<"#define DisplayObj(obj, att) Display_Object(obj, att, #obj); \n" << endl;
+os<<"#define ExecuteCommand(cmd) srvo.ExecuteCommand(cmd); \n" << endl;
 
 return;
@@ -767,5 +788,8 @@
     if(     mModuleImportList[i]=="Samba")  mIncImportList.push_back("samba.h");
     else if(mModuleImportList[i]=="SkyMap") mIncImportList.push_back("skymap.h");
-    else if(mModuleImportList[i]=="PMixer") mIncImportList.push_back("pmixer.h");
+    else if(mModuleImportList[i]=="SkyT") mIncImportList.push_back("skyt.h");
+    else if(mModuleImportList[i]=="FitsIOServer") mIncImportList.push_back("fitsautoreader.h");
+    else if(mModuleImportList[i]=="IFFTW") mIncImportList.push_back("fftwserver.h");
+    else if(mModuleImportList[i]=="LinAlg") mIncImportList.push_back("intflapack.h");
 }
 
Index: trunk/SophyaPI/PIext/cxxexecwin.cc
===================================================================
--- trunk/SophyaPI/PIext/cxxexecwin.cc	(revision 1315)
+++ trunk/SophyaPI/PIext/cxxexecwin.cc	(revision 1319)
@@ -161,7 +161,11 @@
     case 600:    // Bouton Execute C++
       dap->SetBusy();
-      mBut[8]->SetUnSensitive();
+      SetUnSensitive();
+      dap->GetConsole()->AddStr(
+	 "CxxExecWind::Process() - Executing C++ Code ... \n", PIVA_Magenta);
       cxxex->ExecuteCXX(mText[1]->GetText(),mText[0]->GetText());
-      mBut[8]->SetSensitive();
+      dap->GetConsole()->AddStr(
+	 "CxxExecWind ... End of Executing C++ Code \n", PIVA_Magenta);
+      SetSensitive();
       dap->SetReady();
       break;
Index: trunk/SophyaPI/PIext/pistdimgapp.cc
===================================================================
--- trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 1315)
+++ trunk/SophyaPI/PIext/pistdimgapp.cc	(revision 1319)
@@ -113,5 +113,5 @@
 m[5]->AppendCheckItem("Catch SigSEGV", 10604);
 m[5]->AppendCheckItem("ObjMgr Verb", 10605);
-m[5]->AppendCheckItem("CxxExecOption", 10606);
+m[5]->AppendItem("CxxExecOption", 10606);
 
 m[6] = new PIMenu(Menubar(),"Modules");
Index: trunk/SophyaPI/PIext/servnobjm.cc
===================================================================
--- trunk/SophyaPI/PIext/servnobjm.cc	(revision 1315)
+++ trunk/SophyaPI/PIext/servnobjm.cc	(revision 1319)
@@ -1252,4 +1252,11 @@
 }
 
+/* --Methode-- */
+int Services2NObjMgr::ExecuteCommand(string line)
+{
+  if (mImgapp == NULL) return(99);
+  return(mImgapp->CmdInterpreter()->Interpret(line));
+}
+
 // Fonction static
 /* --Methode-- */
Index: trunk/SophyaPI/PIext/servnobjm.h
===================================================================
--- trunk/SophyaPI/PIext/servnobjm.h	(revision 1315)
+++ trunk/SophyaPI/PIext/servnobjm.h	(revision 1319)
@@ -108,4 +108,7 @@
   void 		CloseDLL();  
 
+// Execution de chaine de commande par l'interpreteur
+  int	        ExecuteCommand(string line);
+
 // Utilitaires divers 
   static void   DecodeLoopParameters(string& loop, int& i1, int& i2, int& di);