Index: /trunk/SophyaLib/Manual/sophya_afaire.txt
===================================================================
--- /trunk/SophyaLib/Manual/sophya_afaire.txt	(revision 1345)
+++ /trunk/SophyaLib/Manual/sophya_afaire.txt	(revision 1346)
@@ -4,60 +4,17 @@
           Reza  1/9/2000 14h
           cmv  22/9/2000 18h
+          rz+cmv 24/11/00 16h
 ----------------------------
 
-Fichier "afaire.txt"
-
-- A chaque modif et echange changer la ligne "version" ci-dessus SVP.
-- toujours envoyer ce fichier en "attached" et pas directement
-  dans un mail pour conserver sa structure (lignes trop longues pour pine!)
-
 ================ Zone echange de commentaires ====================
-Reza -> CMV: (1/9/2000)
-  - J'ai fait la modif sa_size_t ds TArray 
-    Pas fait ds cimage.h et .cc (Image<T>)
-    Le FIO_Image<T> est fait - test ds Tests/timg.cc 
-  - J'ai rajoute aussi l'operateur TArray operateur - ()
-    (Pour ecrire TArray XX = -X;)
-  - **** J'ai vu de nouveau des problemes pour l'acces aux 
-    fonctions math.h (sqrt() ,...) quand on inclut 
-    matharr.h ou ces fonctions sont redefinies
-    pour TArray<T>
-    Je me demande si on ne ferait pas mieux de mettre 
-    une majuscule pour les fonctions sur les TArray<T>
-    Sqrt(TArray<T> &) , etc ...
-    Demande aussi l'avis de E.A.
-  - J'ai enleve le inline pour Histo::UpdateHisto()
-    Voir le message a ce sujet
-  - Verfie histos.cc -r 1.12 -r 1.13
-    D.Y. a remplace des int par des int_4 ,
-    Cela me semble OK, mais je prefere que tu verifies
-    (DY a neanmoins introduit des bugs ailleurs que j'ai du corrige) 
-  - gnumd5.c ne donne pas la meme chose sur OSF et IRIX 
-    (ou OSF et mac) 
-    OK entre OSF (alpha) et Linux Intel, etant donne qu'elles
-    ont le meme byte swap , Le rappeler a Eric
-  - PIext : J'ai commence a etendre l'interface des adaptateurs
-    d'objet, j'ai discute avec S. Du pour qu'il essaye de mettre
-    en place l'ecriture 'en ligne' du code C++
      
 ==================================================================
 
 >>>>>>> Module SysTools
-=== gnumd5.c 
-    Le hash-coding donne un resultat different entre machine 
-    big et little endian
-    Etat: A faire par Eric
+
+=== Permettre la creation par copie sur un NDataBlock cree par defaut
+    Etat: a faire par cmv
 
 >>>>>>> Module TArray
-
-=== Proteger l'integrite de TVector/TMatrix
-    contre Resize apres constructeur
-    Etat: FAIT par Reza ( Fin Juillet 2000) 
-
-=== Mettre =(BaseArray) ds Vector
-    Etat: FAIT par Reza   ( Fin Juillet 2000) 
-
-=== Mettre operation entre matrices de differents mapping memoire
-    Etat: FAIT par Reza   ( Fin Juillet 2000) 
 
 === Mettre OMP dans TArray
@@ -67,21 +24,8 @@
           Ne peut etre fait qu'apres la modif typedef size_T 
 
-=== Passer TArray de uint_4 -> int_8 ou int_4 (signed)
-    definir typedef int_T (?)
-    + modif ppersist ecriture/lecture pour ecrire taille/step...
-    en int_8 meme si option int_4 retenue.
-    Etat:  FAIT par Reza ~25 Aout 2000
-           sa_size_t defini ds machdefs.h
-
 === Reporter modif sa_size_t ds Image<T> (cimage.cc .h)
-    Etat: a faire par cmv (?)
+    Etat: a faire par rz
  
 >>>>>>> Module NTools
-
-=== Faire heriter les Image<T> de TMatrix<T>
-    Etat: travail en cours par Reza et cmv
-
-=== PPersist Handler pour Image<T> 
-    Etat: FAIT par Reza  Fin Aout 2000
 
 === Serveur de classes de calcul<T> (Fond,Sigma etc...) sur images:
@@ -90,5 +34,5 @@
     Etat: a faire par reza + cmv
 
-=== Classe FFTServer 9s)
+=== Classe FFTServer
     Correction bug ds FFTmayer
     Etat: a faire par Reza
@@ -99,14 +43,6 @@
     Etat: A faire par Reza
 
-=== Modifier l'ecriture de ppersist NTuple
-    Etat: FAIT par Reza ~25 Aout 2000
+>>>>>>> Module SkyMap
 
-=== Passer Histo,Histo2D HProf en double
-    Pas de donees dans NDataBlock, pas de partage de reference
-    HProf, restructurer HProf::UpdateHisto pour meilleur gestion
-    Etat: FAIT par cmv
-
-
->>>>>>> Module SkyMap
 === Verification de l'interface (constructeur de copie, = )
     des classes local/full sky map
@@ -121,5 +57,4 @@
 === Verifier etat/avancement des transforme en Cl
     Etat: Suivi des travaux G. le Meur (cmv)
- 
 
 >>>>>>> Module FitsIOServer
@@ -127,13 +62,4 @@
 === Y-a-t'il tout ce qu'on veut dans FitsIOServer ?
     Etat: a faire cmv
-
-=== Nouvelles classes ds module FitsIOServer
-    Etat: en cours par G. Le Meur
-    Verifier la conformite du schema avec celui des PPersist
-    Suivi par Reza
-
-=== Interfacage avec FitsIOServer nouvelle version en
-    particulier dans spiapp
-    Etat: a faire par reza + cmv
 
 >>>>>>>> Module IFFTW
@@ -145,34 +71,9 @@
 >>>>>>>> Module LinAlg
 
-=== Ajouter interface pour decomposition LU et SVD en utilisant LaPack
+=== Ajouter interface pour decomposition LU en utilisant LaPack
     Etat: A faire par CMV + Reza
-
 
 >>>>>>>> Module PI PIext
 
-=== Compilation/Link de code C++ utilisant les objets spiapp
-    (le .for du kumac paw en bien mieux...)
-    - Commencer les grandes lignes dans un module separe
-         .... a faire par cmv
-    - La mise en place finale + cosmetique
-         .... a faire par reza + cmv
-
-=== Restructurer piafitting avec des adapteurs de fit
-    pour les divers objets traites. Nettoyage de la "lourdeur"
-    du code.
-    ... apres discussion: identifier ce dont piaffitter a besoin
-        et voir si le + simple n'est pas de rajouter dans les
-        adapteurs deja existants un "GetGeneralFitData"
-        etude a faire par cmv
-    Etat: a faire par reza + cmv
-
-=== Mettre de nouvelles lut piapp et inclure des color tables
-    midas
-    Etat: travail en cours par cmv
-
-=== Extension de l'interface NobjMgrAdapter
-    Etat: Fait par Reza
-    But Permettre d'etendre les fonctionalite de l'interpreteur
-    et permettre aussi de faire du C++ 'en ligne'
-    Discussion
-
+=== Mettre de nouvelles lut (itt_cmv) piapp
+    Etat: travail en cours par cmv + rz