Index: /trunk/SophyaExt/FitsIOServer/fitsfile.cc
===================================================================
--- /trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 1351)
+++ /trunk/SophyaExt/FitsIOServer/fitsfile.cc	(revision 1352)
@@ -712,5 +712,5 @@
 \param <nentries>  number of data to be read
 */
-void FitsInFile::GetBinTabFCol(double* valeurs,int nentries, int NoCol) const
+void FitsInFile::GetBinTabFCol(r_8* valeurs,int nentries, int NoCol) const
     {
       int status= 0;
@@ -749,5 +749,5 @@
  same as previous method with float data 
 */
-void FitsInFile::GetBinTabFCol(float* valeurs,int nentries, int NoCol) const
+void FitsInFile::GetBinTabFCol(r_4* valeurs,int nentries, int NoCol) const
     {
       int status= 0;
@@ -786,5 +786,5 @@
 */
 
-void FitsInFile::GetBinTabFCol(int* valeurs,int nentries, int NoCol) const
+void FitsInFile::GetBinTabFCol(int_4* valeurs,int nentries, int NoCol) const
     {
       int status= 0;
@@ -853,5 +853,5 @@
 \param <nentries>  number of data to be read
 */
-void FitsInFile::GetSingleColumn(double* map, int nentries) const
+void FitsInFile::GetSingleColumn(r_8* map, int nentries) const
 { 
   int status = 0;
@@ -888,5 +888,5 @@
 same as above with float data 
 */
-void FitsInFile::GetSingleColumn(float* map, int nentries) const
+void FitsInFile::GetSingleColumn(r_4* map, int nentries) const
 {
   int status = 0;
@@ -921,5 +921,5 @@
  same as above with int data 
 */
-void FitsInFile::GetSingleColumn( int* map, int nentries) const
+void FitsInFile::GetSingleColumn( int_4* map, int nentries) const
 {
   int status = 0;
@@ -1328,5 +1328,5 @@
 \param <nbData>  number of data to be written
 */
-void FitsOutFile::PutImageToFits(int nbData, double* map) const
+void FitsOutFile::PutImageToFits(int nbData, r_8* map) const
 {
   int status = 0;
@@ -1340,5 +1340,5 @@
 same as previous method with float data 
 */
-void FitsOutFile::PutImageToFits(int nbData, float* map) const
+void FitsOutFile::PutImageToFits(int nbData, r_4* map) const
 {
   int status = 0;
@@ -1352,5 +1352,5 @@
 
  same as previous method with int data */
-void FitsOutFile::PutImageToFits( int nbData, int* map) const
+void FitsOutFile::PutImageToFits( int nbData, int_4* map) const
 {
   int status = 0;
@@ -1480,5 +1480,5 @@
 \param <nentries>  number of data to be written
 */
-void FitsOutFile::PutColToFits(int nocol, int nentries, double* donnees) const
+void FitsOutFile::PutColToFits(int nocol, int nentries, r_8* donnees) const
 {
   int status = 0;
@@ -1509,5 +1509,5 @@
 same as previous method with float data 
 */
-void FitsOutFile::PutColToFits(int nocol, int nentries, float* donnees) const
+void FitsOutFile::PutColToFits(int nocol, int nentries, r_4* donnees) const
 {
   int status = 0;
@@ -1541,5 +1541,5 @@
 same as previous method with int data 
 */
-void FitsOutFile::PutColToFits(int nocol, int nentries, int* donnees) const
+void FitsOutFile::PutColToFits(int nocol, int nentries, int_4* donnees) const
 {
   int status = 0;
Index: /trunk/SophyaExt/FitsIOServer/fitsfile.h
===================================================================
--- /trunk/SophyaExt/FitsIOServer/fitsfile.h	(revision 1351)
+++ /trunk/SophyaExt/FitsIOServer/fitsfile.h	(revision 1352)
@@ -68,5 +68,5 @@
      FitsDataType_int,
      FitsDataType_char,
-     FitsDataType_ASCII,
+     FitsDataType_ASCII
    };
 
@@ -171,7 +171,7 @@
  void   GetBinTabLine(long NoLine, BnTblLine& ligne) ;
  void   GetBinTabLine(int NoLine, float* fdata) ;
- void   GetBinTabFCol(double* valeurs, int nentries, int NoCol) const;
- void   GetBinTabFCol(float* valeurs, int nentries, int NoCol) const;
- void   GetBinTabFCol(int* valeurs, int nentries,  int NoCol) const;
+ void   GetBinTabFCol(r_8* valeurs, int nentries, int NoCol) const;
+ void   GetBinTabFCol(r_4* valeurs, int nentries, int NoCol) const;
+ void   GetBinTabFCol(int_4* valeurs, int nentries,  int NoCol) const;
  void   GetBinTabFCol(char** valeurs,int nentries, int NoCol) const;
 
@@ -189,9 +189,9 @@
 
 
-  void    GetSingleColumn(double* map, int nentries) const;
-
-  void    GetSingleColumn(float*  map, int nentries) const;
-
-  void    GetSingleColumn(int* map, int nentries) const;
+  void    GetSingleColumn(r_8* map, int nentries) const;
+
+  void    GetSingleColumn(r_4*  map, int nentries) const;
+
+  void    GetSingleColumn(int_4* map, int nentries) const;
 
   private :
@@ -240,7 +240,7 @@
 
    void makeHeaderImageOnFits(char type, int nbdim, int* naxisn, DVList* dvl) ;
-   void PutImageToFits( int nbData, double* map) const;
-   void PutImageToFits(int nbData, float* map ) const;
-   void PutImageToFits(int nbData, int* map) const;
+   void PutImageToFits( int nbData, r_8* map) const;
+   void PutImageToFits(int nbData, r_4* map ) const;
+   void PutImageToFits(int nbData, int_4* map) const;
 
 
@@ -253,7 +253,7 @@
 
    void makeHeaderBntblOnFits ( string fieldType, vector<string> Noms, int nentries, int tfields, DVList* dvl, string extname,  vector<int> taille_des_chaines) ;
-   void PutColToFits(int nocol, int nentries, double* donnees) const;
-   void PutColToFits(int nocol, int nentries, float* donnees) const;
-   void PutColToFits(int nocol, int nentries, int* donnees) const;
+   void PutColToFits(int nocol, int nentries, r_8* donnees) const;
+   void PutColToFits(int nocol, int nentries, r_4* donnees) const;
+   void PutColToFits(int nocol, int nentries, int_4* donnees) const;
    void PutColToFits(int nocol, int nentries, char** donnees) const;
    void PutBinTabLine(long NoLine,  BnTblLine& ligne) const;
Index: /trunk/SophyaExt/FitsIOServer/fitsxntuple.cc
===================================================================
--- /trunk/SophyaExt/FitsIOServer/fitsxntuple.cc	(revision 1351)
+++ /trunk/SophyaExt/FitsIOServer/fitsxntuple.cc	(revision 1352)
@@ -260,5 +260,5 @@
    if (dobj_->NIVar() > 0)
      { 
-       int* icolumn = new int[nrows];
+       int_4* icolumn = new int_4[nrows];
        for (k=0; k<dobj_->NIVar();k++)
 	 {